<template>
  <div class="app-container" ref="layout">
    <el-row :gutter="20">
      <el-col :span="5" :xs="24">
        <DepartmentList ref="DepartmentList" @clickdepartment="clickdepartment" :methods="'listOperationNum'">
        </DepartmentList>
      </el-col>
      <el-col :span="19" :xs="24">
        <div ref="topform" class="form">
          <el-form :model="queryParams" ref="queryForms" size="small" :inline="true" v-show="showSearch"
            label-width="68px" @submit.native.prevent>
            <el-form-item label="手术名称" prop="operationName">
              <el-input v-model="queryParams.operationName" placeholder="请输入手术名称" clearable
                @keyup.enter.native="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
              <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </div>
        <div ref="mb8" class="mb8">
          <el-row :gutter="10" class="">
            <el-col :span="1.5">
              <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                :disabled="queryParams.hospitalAgencyId ? false : true"
                v-hasPermi="['operationInfo:operationInfo:add']">新增手术</el-button>
              <el-button type="warning" plain icon="el-icon-upload2" size="mini" @click="handleUpload">导入</el-button>
            </el-col>
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
          </el-row>
        </div>
        <div ref="table">
          <el-table :max-height="maxTableHeight" v-loading="loading" :data="operationInfoList"
            @selection-change="handleSelectionChange">
            <el-table-column label="序号" align="center" prop="sort" type="index" />
            <el-table-column label="手术名称" align="center" prop="operationName" />
            <el-table-column label="术式信息" align="center" prop="operationInfo" />
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
              <template slot-scope="scope">
                <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                  v-hasPermi="['operationInfo:operationInfo:edit']">修改</el-button>
                <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                  v-hasPermi="['operationInfo:operationInfo:remove']">删除</el-button>
              </template>
            </el-table-column>
          </el-table>
        </div>
        <!-- <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" /> -->
        <myPagination v-show="total > 0" :total="total" :pageSize="queryParams.pageSize"
          :indexFromWrap="queryParams.pageNum" @updateCPage="updateCPage"></myPagination>
      </el-col>
    </el-row>
    <!-- 添加或修改手术信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="科室名称" prop="departmentId">
          <el-button @click="clickinnerVisible()" style="
              width: 379px;
              text-align: left;
              height: 36px;
              overflow: hidden;
            " :style="form.departmentName == '请选择科室' ? 'color: #c0c4cc;' : ''
      ">{{ form.departmentName }}</el-button>
        </el-form-item>
        <el-form-item label="手术名称" prop="operationName">
          <el-input v-model="form.operationName" placeholder="请输入手术名称" :disabled="disabled" />
        </el-form-item>
        <el-form-item label="手术排序" prop="sort">
          <el-input-number v-model="form.sort" controls-position="right" :min="0" placeholder="请输入手术排序"
            style="width: 380px" />
        </el-form-item>
        <el-form-item label="术式信息" prop="operationInfo">
          <el-input v-model="form.operationInfo" placeholder="请输入术式信息" type="textarea" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 科室弹框 -->
    <el-dialog title="" :visible.sync="innerVisibleshow" width="1000px" append-to-body
      :before-close="innerVisiblecancel">
      <el-form ref="queryForm" :model="informationqueryParams" :rules="rules" label-width="80px" :inline="true">
        <el-form-item label="科室名称" prop="departmentName" label-width="120">
          <el-input v-model="informationqueryParams.departmentName" placeholder="请输入科室名称" clearable />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="informationInfoinfo">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="addresetQuerylist">重置</el-button>
        </el-form-item>
      </el-form>
      <el-table :data="infolist" @cell-dblclick="nurseclick" v-loading="loading">
        <el-table-column label="请选择" width="100" align="center">
          <template slot-scope="scope">
            <el-button type="primary" style="width: 15px; height: 15px" v-if="form.departmentId == scope.row.id" circle
              @click="nurseclick(scope.row)"></el-button>
            <el-button v-else style="width: 15px; height: 15px" circle @click="nurseclick(scope.row)"></el-button>
          </template>
        </el-table-column>
        <el-table-column property="departmentName" label="科室名称" align="center" :show-overflow-tooltip="true">
        </el-table-column>
      </el-table>
      <!-- <pagination v-show="totaldepartment > 0" :total="totaldepartment" :page.sync="informationqueryParams.pageNum"
        :limit.sync="informationqueryParams.pageSize" @pagination="informationInfoinfo" /> -->
      <myPagination v-show="totaldepartment > 0" :total="totaldepartment" :pageSize="informationqueryParams.pageSize"
        :indexFromWrap="informationqueryParams.pageNum" @updateCPage="updateCPagetwo"></myPagination>
    </el-dialog>
    <!-- 导入弹框 -->
    <el-dialog title="" :visible.sync="innerexport" width="1000px" append-to-body :before-close="exportcancel">
      <addexport @submit="submit" ref="childComponent"></addexport>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitexport">确 定</el-button>
        <el-button @click="innerexport = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listOperationInfo, getOperationInfo, delOperationInfo, addOperationInfo, updateOperationInfo, listOperationNum } from "@/api/operationInfo/operationInfo";
import { department, listDisease } from "@/api/manage/script";
import DepartmentList from '../../components/DepartmentList.vue'
import addexport from "@/views/manage/components/addexport.vue"
import { copyBaselnfo } from "@/api/system/exportinfo";

export default {
  components: {
    DepartmentList,
    addexport
  },
  name: "OperationInfo",
  data() {
    return {
      departmentId: null,
      exportlist: [],
      innerexport: false,
      Nameinfo: null,
      obj: null,
      disabled: false,
      innerVisibleshow: false, //科室弹框
      // 科室
      informationqueryParams: {
        pageNum: 1,
        pageSize: 10,
        departmentName: null,
      },
      departmentName: undefined,
      infolist: [],
      totaldepartment: 0,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 手术信息表格数据
      operationInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        departmentId: null,
        departmentName: null,
        operationName: null,
        operationCode: null,
        operationInfo: null,
        operationRemark: null,
        sort: null,
      },
      maxTableHeight: undefined,
      // 表单参数
      form: {
        id: null,
        departmentId: null,
        departmentName: null,
        operationName: null,
        sort: null,
        operationCode: null,
        operationInfo: null,
        operationRemark: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      },
      // 表单校验
      rules: {
        departmentId: [
          { required: true, message: "所属科室名称不能为空", trigger: "blur" }
        ],
        operationName: [
          { required: true, message: "手术名称不能为空", trigger: "blur" }
        ],
        operationInfo: [
          { required: true, message: "术式信息不能为空", trigger: "blur" }
        ],
        sort: [
          { required: true, message: "手术排序不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    // this.getList();
  },
  watch: {
    'form.sort'(val) {
      if (val) {
        var name = ''
        name = val.toString()
        this.obj = name.split('')
        // if (this.obj.length > 10) {
        //   this.$message({
        //     type: "error",
        //     message: "手术排序最大长度为十位，请正确输入！"
        //   });
        // }
      }
    }
  },
  mounted() {
    this.getMaxTableHeight()
    this.screenChange()
  },
  methods: {
    submit(e) {
      this.exportlist = e
    },
    // 导入确定按钮
    submitexport() {
      var obj = {
        departmentId: this.queryParams.departmentId,
        departmentName: this.departmentName,
        type: 'OPERATOR',
        sourceTemplateIds: this.exportlist,
      }
      copyBaselnfo(obj).then(response => {
        this.$modal.msgSuccess("导入成功");
        this.innerexport = false
        this.$refs.DepartmentList.Departmentlist()
        this.getList();

      });
    },
    // 导入按钮
    handleUpload() {
      if (this.queryParams.departmentId) {
        this.innerexport = true
        if (this.exportlist.length > 0) {
          this.$refs.childComponent.resetTable();
        }
      } else {
        this.$modal.msgError("请先选择左侧科室");

      }
    },
    // 弹框取消
    exportcancel() {
      this.innerexport = false
    },
    // 点击科室
    clickinnerVisible() {
      this.innerVisibleshow = true;
      this.informationInfoinfo();
    },
    // 科室列表
    informationInfoinfo() {
      department(this.informationqueryParams).then((response) => {
        this.infolist = response.rows;
        this.totaldepartment = response.total;
        this.loading = false;
      });
    },
    // 科室名称重置
    addresetQuerylist() {
      this.informationqueryParams = {
        pageNum: 1,
        pageSize: 10,
        hospitalAgencyId: this.queryParams.hospitalAgencyId
      };
      this.informationInfoinfo();
    },
    innerVisiblecancel() {
      this.innerVisibleshow = false;
    },
    // 科室名称圆点按钮
    nurseclick(row) {
      this.form.departmentId = row.id;
      this.form.departmentName = row.departmentName;
      this.departmentName = row.departmentName;
      this.form.diseaseTypeId = '';
      this.diseaseTypeName = '请选择病种';
      this.innerVisibleshow = false;
    },
    /** 查询手术信息列表 */
    getList() {
      this.loading = true;
      listOperationInfo(this.queryParams).then(response => {
        this.operationInfoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        departmentId: null,
        departmentName: null,
        operationName: null,
        operationCode: null,
        operationInfo: null,
        operationRemark: null,
        sort: undefined,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams.departmentId = null;
      this.queryParams.operationName = null;
      this.informationqueryParams.hospitalAgencyId = JSON.parse(localStorage.getItem('user')).hospitalAgencyId
      this.queryParams.hospitalAgencyId = JSON.parse(localStorage.getItem('user')).hospitalAgencyId
      this.resetForm("queryForms");
      this.$refs.DepartmentList.resetQuery()
      // this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    //接收科室列表传值
    clickdepartment(item) {
      this.queryParams.hospitalAgencyId = item.hospitalAgencyId
      this.queryParams.hospitalAgencyName = item.hospitalAgencyName
      this.queryParams.departmentId = item.itemid
      this.departmentName = item.itemName
      this.informationqueryParams.hospitalAgencyId = item.hospitalAgencyId
      if (item.hospitalAgencyId) {
        this.handleQuery();
      }
      this.$forceUpdate()
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      if (this.queryParams.departmentId) {
        this.form.departmentName = this.departmentName
        this.form.departmentId = this.queryParams.departmentId
      } else {
        this.form.departmentName = '请选择科室'
      }
      this.open = true;
      this.title = "添加手术信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      this.form.operationInfo = '';
      const id = row.id || this.ids
      getOperationInfo(id).then(response => {
        this.form = response.data;
        if (!this.form.sort) {
          this.form.sort = undefined
        }
        this.departmentName = response.data.departmentName
        this.open = true;
        this.title = "修改手术信息";
        if (this.title == "修改手术信息") {
          // this.disabled = true
        }
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.form.hospitalAgencyId = this.queryParams.hospitalAgencyId
      this.form.hospitalAgencyName = this.queryParams.hospitalAgencyName
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.obj.length > 10) {
            this.$message({
              type: "error",
              message: "手术排序最大长度为十位，请正确输入！"
            });
          } else {
            if (!this.form.diseaseTypeId) {
              this.form.diseaseTypeName = ''
            }
            if (this.form.id != null) {
              updateOperationInfo(this.form).then(response => {
                this.$modal.msgSuccess("修改成功");
                this.open = false;
                this.$refs.DepartmentList.Departmentlist()
                this.getList();
              });
            } else {
              addOperationInfo(this.form).then(response => {
                this.$modal.msgSuccess("新增成功");
                this.open = false;
                this.getList();
                this.$refs.DepartmentList.Departmentlist()
              });
            }
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('确认要删除该手术？').then(function () {
        return delOperationInfo(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
        this.$refs.DepartmentList.Departmentlist()
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('operationInfo/operationInfo/export', {
        ...this.queryParams
      }, `operationInfo_${new Date().getTime()}.xlsx`)
    },
    updateCPage(index, size) {
      this.queryParams.pageNum = index
      this.queryParams.pageSize = size
      this.getList();
    },
    updateCPagetwo(index, size) {
      this.informationqueryParams.pageNum = index
      this.informationqueryParams.pageSize = size
      this.informationInfoinfo();
    },
    // 获取表格最高高度
    getMaxTableHeight() {
      const windowInnerHeight = window.innerHeight // 屏幕可视高度
      const layoutDiv = this.$refs.layout
      const formDiv = this.$refs.topform
      const mb8Div = this.$refs.mb8
      this.maxTableHeight =
        windowInnerHeight - 134 -
        this.getBoxPadding(layoutDiv) -
        this.getBoxHeight(mb8Div) -
        this.getBoxHeight(formDiv)
    },
    // 屏幕resize监听
    screenChange() {
      // 屏幕resize监听事件：一旦屏幕宽高发生变化，就会执行resize
      window.addEventListener('resize', this.getMaxTableHeight, true)
      // 将屏幕监听事件移除
      // 这步是必须的。离开页面时不移除，再返回，或者进入到别的有相同元素的页面会报错
      // 或者将这里的方法直接写在beforeDestroy函数中也可以
      this.$once('hook:beforeDestroy', () => {
        window.removeEventListener('resize', this.getMaxTableHeight, true)
      })
    },
  }
};
</script>
<style lang="scss" scoped>
::v-deep .el-dialog__body {
  padding-bottom: 60px !important;
}

::v-deep .el-input-number .el-input__inner {
  text-align: left;
}

.left {
  height: calc(100vh - 119px);
  overflow: auto;

  .name {
    font-weight: 700;
    margin-bottom: 10px;
  }

  .listitem {
    width: 100%;
    height: 50px;
    border-bottom: 1px solid #dcdfe6;

    .count {
      display: inline-block;
      position: relative;
      // right: -172px;
      left: 210px;
      color: #a4a6aa;
      top: -35px;
      font-size: 13px;
    }

    .all {
      height: 50px;
      line-height: 50px;
      padding-left: 13px;
    }

    .allactive {
      background: #e8f4ff;
      height: 50px;
      line-height: 50px;
      padding-left: 13px;
      border-left: 3px solid #4d9de7;
    }
  }
}

.button {
  display: inline-block;
  position: relative;
  left: 20px;
  top: -11px;
}

.app-container {
  padding: 20px 0 0 20px !important;
}

::v-deep .el-row {
  height: 100% !important;
}
</style>
